<?php
/*
$Id: include.php 637 2006-11-28 21:53:20Z jmphilippe $
Permet d'inclure une page Wiki dans un autre page

Copyright 2003  Eric FELDSTEIN
Copyright 2003, 2004, 2006  Charles NEPOTE
Copyright 2004  Jean Christophe ANDR
Copyright 2005  Didier Loiseau
Copyright 2006  Jean-Michel PHILIPPE

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/* Paramtres :
 -- page : nom wiki de la page a inclure (obligatoire)
 -- class : nom de la classe de style  inclure (facultatif)
 -- auth : option d'affichage dans le cas d'un utilisateur non autoris (facultatif)
    -- par dfaut : ne fait rien
    -- valeur "noError" : n'affiche aucun message d'erreur
 -- edit : option d'accs en dition  la page incluse (facultatif)
    -- par dfaut : ne fait rien
    -- valeur "show" :  ajoute un lien "[dition]" en haut  droite de la boite
*/ 

// rcuperation du nom de la page  inclure
$incPageName = trim($this->GetParameter('page'));

/**
* @todo amliorer le traitement des classes css
*/
$classes = 'include';
if ($this->GetParameter('class'))
{
	$array_classes = explode(' ', $this->GetParameter('class'));
	foreach ($array_classes as $c)
	{
		if ($c && preg_match('`^[A-Za-z0-9-_]+$`', $c))
        {
            $classes .= ' '.$c;
        }
	} 
} 

// Affichage de la page ou d'un message d'erreur
//
if (empty($incPageName))
{
	echo '<div class="error"><p><strong>Erreur ActionInclude</strong> : Le param&egrave;tre "page" est manquant.</p></div>';
}
elseif ($this->IsIncludedBy($incPageName))
{
	$inclusions = $this->GetAllInclusions();
	$pg = strtolower($incPageName); // on l'effectue avant le for sinon il sera recalcul  chaque pas
	$err = '[[' . $pg . ']]';
	for($i = 0; $inclusions[$i] != $pg; $i++)
	{
		$err = '[[' . $inclusions[$i] . ']] > ' . $err;
	} 
	echo "<div class=\"error\">\n\t<p><strong>Erreur ActionInclude</strong> : Impossible pour la page '[[$incPageName]]' de s'inclure en elle m&ecirc;me//";
	echo ($i ? ":---**Chaine d'inclusions**: [[$pg]] > $err": '.'); // si $i = 0, alors c'est une page qui s'inclut elle-mme directement...
	echo "</p>\n</div>\n";
}
elseif (!$this->HasAccess('read', $incPageName) && $this->GetParameter('auth')!='noError')
{
	echo "<div class=\"error\">\n\t<p><strong>Erreur ActionInclude</strong> : Lecture de la page inclue '\"\"$incPageName\"\"' non autoris&eacute;e.</p>\n</div>\n";
}
elseif (!$incPage = $this->LoadPage($incPageName))
{
	echo "<div class=\"error\">\n\t<p><strong>Erreur ActionInclude</strong> : La page inclue '[[$incPageName]]' ne semble pas exister...</p>\n</div>\n";
} 
// Affichage de la page quand il n'y a pas d'erreur
elseif ($this->HasAccess('read', $incPageName))
{
	$this->RegisterInclusion($incPageName);
	$output = $this->Format($incPage['body']);
	if (isset($classes))
	{
		if($this->GetParameter('edit')=='show')
			$editLink = '<div class="editlink"><a href="' . $this->Href("edit", $incPageName) . "\">[&Eacute;dition]</a></div>\n";
		else $editLink = "";
		// Affichage
		echo '<div class="' . $classes . "\">\n" . $editLink . $output . "</div>\n";
	}
	else echo $output;
	$this->UnregisterLastInclusion();
}
?>