<?php

/*
recentchanges.php
Copyright (c) 2002, Hendrik Mans <hendrik@mans.de>
Copyright 2002, 2003 David DELON
Copyright 2002, 2003 Charles NEPOTE
Copyright 2002 Patrick PAUL
Copyright  2003  Eric DELORD
Copyright  2006  Jean-Michel PHILIPPE
All rights reserved.
Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:
1. Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.
3. The name of the author may not be used to endorse or promote products
derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
// Which is the max number of pages to be shown ?
if ($max = $this->GetParameter("max"))
{
    if ($max=="last") $max=50; else $last = (int) $max;
}
elseif ($user = $this->GetUser())
{
    $max = $user["changescount"];
}
else
{
    $max = 50;
}

// Mode d'affichage : tri simple, ou avec des sous-sections dates
if ($group = $this->GetParameter("group")) {
	if ($group != "date" && $group != "no") $group = "date";
}
else  $group = "date";

// Show recently changed pages
echo "<div class=\"recentchanges\">\n";
echo "<p>Voici la liste des derni&egrave;res pages modifi&eacute;es</p>\n";
if ($pages = $this->LoadRecentlyChanged($max))
{
	if ($group == "no")
	{
		$odd_even = false;
		echo "<ul>\n";
		foreach ($pages as $i => $page)
		{
			$odd_even = !$odd_even;
			$liclass = ($odd_even) ? 'odd' : 'even';
			
			// echo entry
			echo "<li class=\"$liclass\">";
			echo '<span class="date">',substr($page["time"],0,16),'</span>';
			echo ' (<a class="history" href="',
				$this->Href('revisions',$page["tag"]),
				'" title="Consulter l\'historique de cette page">hist.</a>) ';
			echo '<a class="page" href="',
				$this->Href('',$page["tag"]),
				'" title="Consulter cette page">',$page["tag"],'</a>';
			echo ' . . . par&nbsp;',$this->Format($page["user"]);
			echo "</li>\n";
		}
		echo "</ul>\n";
	}
	else
	{
		$curday='';
		echo "<dl>\n";
        foreach ($pages as $i => $page)
		{
			// day header
			list($day, $time) = explode(" ", $page["time"]);
			if ($day != $curday)
			{
				if ($curday) echo "</ul></dd>\n" ;
				echo "<dt>$day</dt>\n<dd><ul>\n" ;
				$curday = $day;
				$odd_even = false;
			}
			$odd_even = !$odd_even;
			$liclass = ($odd_even) ? 'odd' : 'even';
			
			// echo entry
			echo "<li class=\"$liclass\">";
			echo '<span class="date">',substr($time,0,5),'</span>';
			echo ' (<a class="history" href="',
				$this->Href('revisions',$page["tag"]),
				'" title="Consulter l\'historique de cette page">hist.</a>) ';
			echo '<a class="page" href="',
				$this->Href('',$page["tag"]),
				'" title="Consulter cette page">',$page["tag"],'</a>';
			echo ' . . . par&nbsp;',$this->Format($page["user"]);
			echo "</li>\n";
		}
		echo "</ul></dd>\n</dl>\n";
	}
}
echo "</div>\n";
?>
