<?php
/*
recentcomments.php
Copyright (c) 2002, Hendrik Mans <hendrik@mans.de>
Copyright 2002, 2003 David DELON
Copyright 2002, 2005 Charles NEPOTE
Copyright 2002 Patrick PAUL
Copyright 2006 Jean-Michel PHILIPPE

All rights reserved.
Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:
1. Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.
3. The name of the author may not be used to endorse or promote products
derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

// Which is the max number of comments to be shown ?
if ($max = $this->GetParameter("max"))
{
    if ($max=="last") $max=50;
    else $last = (int) $max;
}
else
{
    $max = 50;
}

// Show recent comments
echo "<div class=\"recentcomments\">\n";
echo "<p>Voici la liste des derniers commentaires ajout&eacute;s.</p>\n";
if ($comments = $this->LoadRecentComments($max))
{
	$curday = '';
	echo "<dl>\n";
	foreach ($comments as $comment)
	{
		// day header
		list($day, $time) = explode(" ", $comment["time"]);
		if ($day != $curday)
		{
			if ($curday) echo "</ul></dd>\n" ;
			echo "<dt>$day</dt>\n<dd><ul>\n" ;
			$curday = $day;
			$odd_even = false;
		}
		$odd_even = !$odd_even;
		$liclass = ($odd_even) ? 'odd' : 'even';

		// echo entry
		echo "<li class=\"$liclass\">";
		echo '<span class="date">',substr($comment["time"],0,5),'</span>';
		echo '<a class="page" href="',
			$this->Href('',$comment["comment_on"],"show_comments=1"),"#",$comment["tag"],
			'" title="Consulter cette page">',$comment["comment_on"],'</a>';
		echo ' . . . par&nbsp;',$this->Format($comment["user"]);
		echo "</li>\n";
	}
	echo "</ul></dd>\n</dl>\n";
}
else
{
	echo "<div class=\"error\">\n\t<p>Pas de commentaires r&eacute;cents.</p>\n</div>\n\n";
}
echo "</div>\n";
?>
