<?php
/*
usersettings.php
Copyright (c) 2002, Hendrik Mans <hendrik@mans.de>
Copyright 2002, 2003 David DELON
Copyright 2002, 2003 Charles NEPOTE
Copyright 2002  Patrick PAUL
Copyright 2007  Xavier GARREAU
All rights reserved.
Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:
1. Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.
3. The name of the author may not be used to endorse or promote products
derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
if (!isset($_REQUEST["action"])) $_REQUEST["action"] = '';
if ($_REQUEST["action"] == "logout")
{
	$this->LogoutUser();
	$this->SetMessage("Vous &ecirc;tes maintenant d&eacute;connect&eacute; !");
	$this->Redirect($this->href());
}
else if ($user = $this->GetUser())
{
	
	// is user trying to update?
	if ($_REQUEST["action"] == "update")
	{
		$this->Query("update ".$this->GetConfigValue("table_prefix")."users set ".
			"email = '".$this->dbObject->escape_string($_POST["email"])."', ".
			"doubleclickedit = '".$this->dbObject->escape_string($_POST["doubleclickedit"])."', ".
			"show_comments = '".$this->dbObject->escape_string($_POST["show_comments"])."', ".
			"revisioncount = '".$this->dbObject->escape_string($_POST["revisioncount"])."', ".
			"changescount = '".$this->dbObject->escape_string($_POST["changescount"])."', ".
			"motto = '".$this->dbObject->escape_string($_POST["motto"])."' ".
			"where name = '".$user["name"]."'");
		
		$this->SetUser($this->LoadUser($user["name"]));
		
		// forward
		$this->SetMessage("Param&egrave;tres sauvegard&eacute;s !");
		$this->Redirect($this->href());
	}
	
	if ($_REQUEST["action"] == "changepass")
	{
			// check password
			$password = $_POST["password"];			
			if (preg_match("/ /", $password)) $error = "Les espaces ne sont pas permis dans les mots de passe.";
			else if (strlen($password) < 5) $error = "Mot de passe trop court.";
			else if ($user["password"] != md5($_POST["oldpass"])) $error = "Mot de passe erron&eacute;&nbsp;!"; 
			else
			{
				$this->Query("update ".$this->GetConfigValue("table_prefix")."users set "."password = '".md5($this->dbObject->escape_string($password))."' "."where name = '".$user["name"]."'");				
				$this->SetMessage("Mot de passe chang&eacute; !");
				$user["password"]=md5($password);
				$this->SetUser($user);
				$this->Redirect($this->href());
			}
	}
	// user is logged in; display config form
	?>
	<h1>Bonjour, <?php echo $this->Link($user["name"]) ?>&nbsp;!</h1>
	<?php
	if (isset($error))
		echo '<div class="error"><p>', $this->Format($error), "</p></div>\n";
	?>
	<?php echo $this->FormOpen('','','post','usersettings'); ?>
	<input type="hidden" name="action" value="update" />
	<h3>Vos param&egrave;tres</h3>
	<fieldset class="top">
		<legend>Donn&eacute;es personnelles</legend>
		<label title="Votre adresse email">
			Messagerie &eacute;lectronique
			<input id="email" name="email" value="<?php echo htmlentities($user["email"]) ?>" />
		</label>
		<label>
			Votre devise
			<input id="motto" name="motto" value="<?php echo htmlentities($user["motto"]) ?>" />
		</label>
	</fieldset>
	
	<fieldset class="middle">
		<legend>Pr&eacute;f&eacute;rences de navigation</legend>
		<label title="Permet d'&eacute;diter une page en double-cliquant dans la page">
			&Eacute;dition en double-cliquant
			<input type="checkbox" id="doubleclickedit" name="doubleclickedit" value="Y" <?php echo $user["doubleclickedit"] == "Y" ? "checked=\"checked\"" : "" ?> />
			<input type="hidden" name="doubleclickedit" value="N" />
		</label>
		<label title="Afficher par d&eacute;faut les commentaires en bas de page">
			Montrer les commentaires
			<input type="checkbox" id="show_comments" name="show_comments" value="Y" <?php echo $user["show_comments"] == "Y" ? "checked\"checked\"" : "" ?> />
			<input type="hidden" name="show_comments" value="N" />
		</label>
		<label title="Longueur maximale de l'historique des commentaires">
			Nombre de derniers commentaires
			<input id="changescount" name="changescount" value="<?php echo htmlentities($user["changescount"]) ?>" />
		</label>
		<label title="Longueur maximale de l'historique des pages">
			Nombre de versions de pages
			<input id="revisioncount" name="revisioncount" value="<?php echo htmlentities($user["revisioncount"]) ?>" />
		</label>
		<input type="submit" value="Mise &agrave; jour" />
		<input type="button" value="D&eacute;connexion" onclick="document.location='<?php echo $this->href("", "", "action=logout"); ?>'" />
	</fieldset>
	<?php echo $this->FormClose(); ?>
	
	<h3>Pour changer de mot de passe</h3>
	<?php echo $this->FormOpen('','','post','usersettings'); ?>
	<input type="hidden" name="action" value="changepass" />
	<fieldset>
		<legend>Compl&eacute;tez les champs suivants</legend>
		<label>
			Votre ancien mot de passe
			<input type="password" id="oldpass" name="oldpass" />
		</label>
		<label>
			Nouveau mot de passe <sup>*</sup>
			<input type="password" id="password" name="password" />
		</label>
		<input type="submit" value="Changer" />
	</fieldset>
	<?php echo $this->FormClose() ?>
	<p class="footnotes"><sup>*</sup> 5 caract&egrave;res minimum</p>
	<?php
}
else
{
	// user is not logged in
	
	// is user trying to log in or register?
	if ($_REQUEST["action"] == "login")
	{
		// if user name already exists, check password
		if ($existingUser = $this->LoadUser($_POST["name"]))
		{
			// check password
			if ($existingUser["password"] == md5($_POST["password"]))
			{
				$this->SetUser($existingUser, $_POST["remember"]);
				$this->Redirect($this->href());
			}
			else
			{
				$error = "Mot de passe erron&eacute;&nbsp;!";
			}
		}
		// otherwise, create new account
		else
		{
			$name = trim($_POST["name"]);
			$email = trim($_POST["email"]);
			$password = $_POST["password"];
			$confpassword = $_POST["confpassword"];

			// check if name is WikkiName style
			if (!$this->IsWikiName($name)) $error = "Votre nom d'utilisateur doit &ecirc;tre format&eacute; en NomWiki.";
			else if (!$email) $error = "Vous devez sp&eacute;cifier une adresse de messagerie &eacute;lectronique.";
			else if (!preg_match("/^.+?\@.+?\..+$/", $email)) $error = "Ceci ne ressemble pas &agrave; une adresse de messagerie &eacute;lectronique.";
			else if ($confpassword != $password) $error = "Les mots de passe n'&eacute;taient pas identiques.";
			else if (preg_match("/ /", $password)) $error = "Les espaces ne sont pas permis dans un mot de passe.";
			else if (strlen($password) < 5) $error = "Mot de passe trop court. Un mot de passe doit contenir au minimum 5 caract&egrave;res alphanum&eacute;riques.";
			else
			{
				$this->Query("insert into ".$this->GetConfigValue("table_prefix")."users".
				    "(signuptime,name,email,password) ".
					"VALUES ('".date('Y-m-d H:i:s')."', ".
					"'".$this->dbObject->escape_string($name)."', ".
					"'".$this->dbObject->escape_string($email)."', ".
					"'".md5($this->dbObject->escape_string($_POST["password"]))."')");

				// log in
				$this->SetUser($this->LoadUser($name));

				// forward
				$this->Redirect($this->href());
			}
		}
	}
	
	?>
	<h1>Autentification et cr&eacute;ation de compte</h1>
	<?php
	if (isset($error))
		echo '<div class="error"><p>', $this->Format($error), "</p></div>\n";
	?>
	<p>Pour cr&eacute;er un nouveau compte utilisateur, remplissez tous les champs. Pour vous identifier par la suite, ne remplissez que les deux de la premi&egrave;re section.</p>
	<?php echo $this->FormOpen('','','post','usersettings'); ?>
	<h3>Si vous &ecirc;tes d&eacute;j&agrave; enregistr&eacute;</h3>
	<fieldset class="top">
		<legend>Identifiez-vous ici</legend>
		<input type="hidden" name="action" value="login" />
		<label title="Ne prenez pas celui d'une page existante">
			<?php echo $this->Format("Votre NomWiki") ?>
			<input id="name" name="name" value="<?php if (isset($name)) echo htmlentities($name) ?>" />
		</label>
		<label title="N'oubliez pas votre mot de passe !">
			Mot de passe <sup>*</sup>
			<input type="password" id="password" name="password" />
		</label>
		<label title="Rester connect&eacute; pour la prochaine visite visite">
			Se souvenir de moi
			<input type="checkbox" id="remember" name="remember" value="1" />
			<input type="hidden" name="remember" value="0" />
		</label>
		<input type="submit" value="Identification" />
	</fieldset>
	<p class="footnotes"><sup>*</sup> 5 caract&egrave;res minimum</p>
	
	<h3>Pour c&eacute;er un compte</h3>
	<fieldset class="bottom">
		<legend>Remplissez aussi les champs suivants</legend>
		<label title="Resaisissez votre mot de passe">
			Confirmation du mot de passe
			<input type="password" id="confpassword" name="confpassword" />
		</label>
		<label title="Votre adresse email">
			Messagerie &eacute;lectronique
			<input id="email" name="email" value="<?php if (isset($email)) echo htmlentities($email) ?>" />
		</label>
		<input type="submit" value="Nouveau compte" />
	</fieldset>
	<?php echo $this->FormClose() ?>
	<p><em><?php echo $this->GetWakkaName() ?></em> s'engage &agrave; ne pas utiliser vos informations personnelles &agrave; des fins commerciales et &agrave; ne pas les divulger &agrave; des tiers.</p>
	<?php
}
?>

