<?php
/*
$Id: acls.php 708 2006-12-21 00:47:46Z lkppo $
Copyright (c) 2002, Hendrik Mans <hendrik@mans.de>
Copyright 2002, 2003 David DELON
Copyright 2002, 2003 Charles NEPOTE
Copyright  2003  Eric FELDSTEIN
Copyright  2003  Jean-Pascal MILCENT
Copyright  2004  Jean Christophe ANDR
All rights reserved.
Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:
1. Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.
3. The name of the author may not be used to endorse or promote products
derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

// Vrification de scurit
if (!defined("WIKINI_VERSION"))
{
	die ("acc&egrave;s direct interdit");
}

ob_start();

?>
<div id="text"><div class="deco-body">
<?php

if ($this->UserIsOwner() && $this->page)
{
	if ($_POST)
	{
		// store lists
		$this->SaveAcl($this->GetPageTag(), "read", $_POST["read_acl"]);
		$this->SaveAcl($this->GetPageTag(), "write", $_POST["write_acl"]);
		$this->SaveAcl($this->GetPageTag(), "comment", ($this->page['comment_on'] ? "" : $_POST["comment_acl"]));
		$message = "Droits d\'acc&egrave;s mis &agrave; jour ";//$message = "Access control lists updated";
		
		// change owner?
		if ($newowner = $_POST["newowner"])
		{
			$this->SetPageOwner($this->GetPageTag(), $newowner);
			$message .= " et changement du propri&eacute;taire. Nouveau propri&eacute;taire : ".$newowner;//$message .= " and gave ownership to ".$newowner;
		}

		// redirect back to page
		$this->SetMessage($message."!");
		$this->Redirect($this->Href());
	}
	else
	{
		// load acls
		$readACL = $this->LoadAcl($this->GetPageTag(), "read");
		$writeACL = $this->LoadAcl($this->GetPageTag(), "write");
		$commentACL = $this->LoadAcl($this->GetPageTag(), "comment");

		// show form
		?>
		<h1>Droits d'acc&egrave;s de la page</h1>
		<p>Ce formulaire permet de changer les droits d'acc&egrave;s en lecture et en &eacute;criture de la page <?php echo  $this->ComposeLinkToPage($this->GetPageTag()) ?> ainsi que le droit d'ajouter ou non des commentaires. Vous pouvez utiliser le signe <span>*</span> (&eacute;toile) qui d&eacute;signe tous les utilisateurs.</p>
		
		<?php echo $this->FormOpen("acls") ?>
		<label>
			Droits de lecture
			<textarea name="read_acl" rows="4" cols="20"><?php echo $readACL["list"] ?></textarea>
		</label>
		<label>
			Droits d'&eacute;criture
			<textarea name="write_acl" rows="4" cols="20"><?php echo $writeACL["list"] ?></textarea>
		</label>
<?php
		if (!$this->page['comment_on'])
		{
?>
		<label>
			Droits des commentaires
			<textarea name="comment_acl" rows="4" cols="20"><?php echo $commentACL["list"] ?></textarea>
		</label>
<?php
		}
?>
		<label>
			Gestionnaire de la page
			<select name="newowner">
				<option value="">Ne rien modifier</option>
				<option value="">----------------</option>
				<?php
				if ($users = $this->LoadUsers())
				{
					foreach($users as $user)
					{
						echo "\t\t\t<option value=\"",htmlentities($user["name"]),"\">",$user["name"],"</option>\n";
					}
				}
				?>
			</select>
		</label>
		<input type="submit" value="Enregistrer" accesskey="s" />
		<input type="button" value="Annuler" onclick="history.back();" />
		<?php
		echo$this->FormClose();
	}
}
else
{
	echo "<div class=\"error\"><p>Vous ne pouvez pas g&eacute;rer les permissions de cette page.</p></div>";
}

?>
</div></div>
<?php

$content = ob_get_clean();
echo $this->Header();
echo $content;
echo $this->Footer();

?>