<?php
/*
$Id: edit.php 736 2007-01-26 06:11:28Z lkppo $
Copyright (c) 2002, Hendrik Mans <hendrik@mans.de>
Copyright 2002, 2003 David DELON
Copyright 2002, 2003 Charles NEPOTE
Copyright 2002, 2003 Patrick PAUL
Copyright 2003  Eric FELDSTEIN
Copyright 2004  Jean Christophe ANDR
Copyright 2005  Didier Loiseau
All rights reserved.
Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:
1. Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.
3. The name of the author may not be used to endorse or promote products
derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

// Vrification de scurit
if (!defined('WIKINI_VERSION')) {
	die ('acc&egrave;s direct interdit');
}

// on initialise la sortie:
$output = '';

if ($this->HasAccess('write') && $this->HasAccess('read')) {
	if (!empty($_POST['submit'])){
		$submit = $_POST['submit'];
	} else {
		$submit = false;
	}
	
	// fetch fields
	if (empty($_POST['previous'])){
		$previous = $this->page['id'];
	} else {
		$previous = $_POST['previous'];
	}
	if (empty($_POST['body'])){
		$body = $this->page['body'];
	} else {
		$body = $_POST['body'];
	}


	switch ($submit){
		case 'Aperu':
			$temp = $this->SetInclusions(); // a priori, a ne sert  rien, mais on ne sait jamais...
			$this->RegisterInclusion($this->GetPageTag()); // on simule totalement un affichage normal
			$page_html = $this->Format($body);
			$boutons = 
				"\t\t\t<legend>Op&eacute;ration &agrave; effectuer sur la page</legend>\n".
				"\t\t\t<input name=\"submit\" type=\"submit\" value=\"Sauver\" accesskey=\"s\" />\n".
				"\t\t\t<input name=\"submit\" type=\"submit\" value=\"R&eacute;&eacute;diter\" accesskey=\"p\" />\n".
				"\t\t\t<input type=\"button\" value=\"Annulation\" onclick=\"document.location='" . addslashes($this->href()) . "';\" />\n";
			$output .= "<div id=\"prev_alert\" title=\"Les modifications n'ont pas encore &eacute;t&eacute; sauvegard&eacute;es\">Aper&ccedil;u de la page modifi&eacute;e</div>\n\t";
			$output .= $this->FormOpen("edit");
			$output .= "\t\t<input type=\"hidden\" name=\"previous\" value=\"$previous\" />\n".
				"\t\t<input type=\"hidden\" name=\"body\" value=\"".htmlentities($body)."\" />\n";
			if (strlen($page_html) > 1000)
			{	// ajouter des boutons en haut des pages longues
				$output .= "\t<fieldset class=\"top\">\n$boutons\t</fieldset>\n";
			}
			$output .= $page_html."\n\n";
			$output .= "\t<fieldset class=\"bottom\">\n$boutons\t</fieldset>\n";
			$output .= $this->FormClose();
			$this->SetInclusions($temp);
			$themeMgrObj = &$this->GetThemeManager();
			$themeMgrObj->addBodyClass('preview');
			break;
			
		// pour les navigateurs n'interprtant pas le javascript
		case 'Annulation':
			$this->Redirect($this->Href());
			exit; // scurit

		// only if saving:
		case 'Sauver':

			// Cacul du dpassement de capacit de la page
			$PageSizeOverflow = strlen($body) - $this->GetConfigValue("max_page_size");

			// check for overwriting
			if ($this->page && $this->page['id'] != $_POST['previous']) {
				$error = 'ALERTE : '
					."Cette page a &eacute;t&eacute; modifi&eacute;e par quelqu'un d'autre pendant que vous l'&eacute;ditiez.<br />\n"
					."Veuillez copier vos changements et r&eacute;&eacute;diter cette page.\n";
			// Vrifier que la taille maximale de page n'est pas dpasse
			} elseif ($PageSizeOverflow > 0) {
				$error = 'ALERTE : '
					."Cette page est trop longue. Elle ne doit pas d&eacute;passer <b>"
					.$this->GetConfigValue("max_page_size")." caractres</b> "
					."(".$PageSizeOverflow." caractres de trop).<br />\n"
					."Veuillez all&eacute;ger son contenu  ou le rpartir sur plusieurs pages.\n";
			} else { // store
				$body = str_replace("\r", '', $body);
				
				// teste si la nouvelle page est differente de la prcdente 
				if(rtrim($body)==rtrim($this->page["body"])) {
					$this->SetMessage('Cette page n\\\'a pas &eacute;t&eacute; enregistr&eacute;e car elle n\\\'a subi aucune modification.');
					$this->Redirect($this->href());
				} else { // scurit
					// add page (revisions)
					$this->SavePage($this->GetPageTag(), $body);
					
					// forward
					if ($this->page['comment_on']) {
						$this->Redirect($this->href('', $this->page['comment_on']).'#'.$this->GetPageTag());
					}
					else {
						$this->Redirect($this->href());
					}
				}
				
				// scurit
				exit;
			}
			// NB.: en cas d'erreur on arrive ici, donc default sera excut...
		default:
			// display form
			if (isset($error)) {
				$output .= "<div class=\"error\">$error</div>\n";
			}
			
			// append a comment?
			if (isset($_REQUEST['appendcomment'])) {
				$body = trim($body)."\n\n----\n\n-- ".$this->GetUserName().' ('.strftime('%c').')';
			}

			if ($this->page["comment_on"]) {
				$edit_target = "ce commentaire";
			} else {
				$edit_target = "cette page";
			}
			
			$output .=
				'<div class="infos">'."\n".
				"	<p>Modifiez le texte de $edit_target dans le formulaire ci-dessous puis cliquez sur le bouton Aper&ccedil;u ou Sauver en bas pour visualiser vos modifications ou les enregistrer.</p>\n".
				'	<p class="help"><a href="'.$this->href('','ReglesDeFormatage#go_Page_Title').'" onclick="window.open(this.href,\'wikini_popup\',
	\'alwaysRaised=yes,dependent=yes,toolbar=no,height=420,width=600,menubar=no,resizable=yes,scrollbars=yes,status=no\'); return false;">Afficher l\'aide &agrave; la r&eacute;daction</a></p>'."\n".
				"</div>\n".
				$this->FormOpen('edit').
				"\t\t<input type=\"hidden\" name=\"previous\" value=\"$previous\" />\n".
				"<textarea id=\"body\" name=\"body\" cols=\"60\" rows=\"40\" class=\"edit\">\n".
				htmlspecialchars($body).
				"</textarea>\n".
				"\t\t<script type=\"text/javascript\">\n".
				"\t\t\tdocument.getElementById(\"body\").onkeydown=fKeyDown;\n".
				"\t\t\tdocument.getElementById(\"body\").onkeypress=fKeyDown;\n".
				"\t\t</script>\n".
				"\t\t<fieldset class=\"bottom\">\n".
				"\t\t<legend>Op&eacute;ration &agrave; effectuer sur la page</legend>\n".
				($this->GetConfigValue('preview_before_save') ? '' : "\t\t\t<input name=\"submit\" type=\"submit\" value=\"Sauver\" accesskey=\"s\" />\n").
				"\t\t\t<input name=\"submit\" type=\"submit\" value=\"Aper&ccedil;u\" accesskey=\"p\" />\n".
				"\t\t\t<input type=\"button\" value=\"Annulation\" onclick=\"document.location='" . addslashes($this->href()) . "';\" />\n".
				"\t\t</fieldset>\n\t".
				$this->FormClose();
	} // switch
} else {
	$output .= "<div class=\"error\">Vous n'avez pas acc&egrave;s en &eacute;criture &agrave; cette page !</div>\n";
}

echo $this->Header();
echo "<div id=\"text\"><div class=\"deco-body\">\n$output\n</div></div>\n";
echo $this->Footer();
?>
