<?php
/*
revisions.php
Copyright (c) 2002, Hendrik Mans <hendrik@mans.de>
Copyright 2002, 2003 David DELON
Copyright 2002, 2003 Charles NEPOTE
Copyright  2003  Eric FELDSTEIN
All rights reserved.
Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:
1. Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.
3. The name of the author may not be used to endorse or promote products
derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

// Vrification de scurit
if (!defined("WIKINI_VERSION"))
{
	die ("acc&egrave;s direct interdit");
}

ob_start();
?>
<div id="text"><div class="deco-body">
<?php
// load revisions for this pageif
if ($this->HasAccess("read"))
{
	if (!isset($output)) $output = '';
	if ($pages = $this->LoadRevisions($this->GetPageTag()))
	{
		$output .= "<h1><a id=\"go_Page_Hist\"></a>Archives de la page</h1>\n";
		$output .= "<p>Cet outil permet de consulter de pr&eacute;c&eacute;dentes versions de la page ".$this->ComposeLinkToPage($this->GetPageTag())." ou d'afficher les diff&eacute;rences existant entre deux versions de l'historique. Pour voir une pr&eacute;c&eacute;dente version, il suffit de cliquer sur la date de celle-ci. Pour en comparer deux, il faut les s&eacute;lectionner puis cliquer sur le bouton <em>Voir Diff&eacute;rences</em>.</p>\n";
		$output .= $this->FormOpen("diff", "", "get");
		$output .= "<p>\n";
		$output .= "<input type=\"submit\" value=\"Voir Diff&eacute;rences\" />\n";
		$output .= "<input type=\"checkbox\" id=\"fastdiff\" name=\"fastdiff\" />\n";
		$output .= "<label for=\"fastdiff\">Affichage simplifi&eacute;</label>\n";
		$output .= "</p>\n";
		$output .= "<fieldset>\n";
		$output .= "\t<legend>Cliquez sur une version ou cochez celles &agrave; comparer</legend>\n";
		$output .= "\t<ul>\n";
		if ($user = $this->GetUser())
		{
			$max = $user["revisioncount"];
		}
		else
		{
			$max = 20;
		}
	
		$c = 0;
		foreach ($pages as $page)
		{
			$c++;
			$odd_even = ($c%2) ? 'odd' : 'even';
			if (($c <= $max) || !$max)
			{
				$output .= "\t\t<li class=\"$odd_even\">\n";
				$output .= "\t\t<label for=\"a$c\">Comparer celle-ci</label>\n";
				$output .= "\t\t\t<input type=\"radio\" id=\"a$c\" name=\"a\" value=\"".$page["id"]."\" ".($c == 1 ? "checked=\"checked\"" : "")." title=\"Comparer celle-ci\" />\n";
				$output .= "\t\t<label for=\"b$c\">Avec celle-l&agrave;</label>\n";
				$output .= "\t\t\t<input type=\"radio\" id=\"b$c\" name=\"b\" value=\"".$page["id"]."\" ".($c == 2 ? "checked=\"checked\"" : "")." title=\"Avec celle-l&agrave;\" />\n";
				$output .= "\t\t<a class=\"date\" title=\"Voir cette version de la page\" href=\"".$this->href("show")."&amp;time=".urlencode($page["time"])."\">".substr($page["time"],0,16)."</a>";
				$output .= " par ".$this->Format($page["user"])."\n";
				$output .= "</li>\n";
			}
		}
		$output .= "\t</ul>\n</fieldset>\n".$this->FormClose()."\n";
		$output .= "<h1>Mode d'affichage</h1>\n";
		$output .= "<p>Il y a deux modes d'affichage des diff&eacute;rences. Par d&eacute;faut, la totalit&eacute; de la page est affich&eacute;e et le texte ajout&eacute; ou supprim&eacute; est visualis&eacute; avec un formatage diff&eacute;rent du formatage habituel. Si la case <em>Affichage simplifi&eacute;</em> est coch&eacute;e, alors seule les portions de texte ajout&eacute;es ou supprim&eacute;es seront affich&eacute;es dans des sections distinctes.</p>\n";
	}
	echo $output ;
}
else
{
	echo "<div class=\"warning\"><p>Vous n'avez pas acc&egrave;s &agrave; cette page.</p></div>";
}
?>
</div></div>
<?php

$content = ob_get_clean();
echo $this->Header();
echo $content;
echo $this->Footer();

?>
