<?php
/*
$Id: show.php 736 2007-01-26 06:11:28Z lkppo $
Copyright (c) 2002, Hendrik Mans <hendrik@mans.de>
Copyright 2002, 2003 David DELON
Copyright 2002, 2003 Charles NEPOTE
Copyright 2003  Eric DELORD
Copyright 2003  Eric FELDSTEIN
Copyright 2004  Jean Christophe ANDR
Copyright 2005  Didier Loiseau
Copyright 2006  Jean-Michel PHILIPPE, Stphane AULERY
All rights reserved.
Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:
1. Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.
3. The name of the author may not be used to endorse or promote products
derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

// Vrification de scurit
if (!defined("WIKINI_VERSION"))
{
	die ("acc&egrave;s direct interdit");
}

// Generate page before displaying the header, so that it might interract with the header
ob_start();

echo '<div id="text"';
echo (($user = $this->GetUser()) && ($user['doubleclickedit'] == 'N') || !$this->HasAccess('write')) ? '' : ' ondblclick="doubleClickEdit(event);"';
echo '><div class="deco-body">'."\n";

if ($HasAccessRead=$this->HasAccess("read"))
{
	if ($this->PageExists($this->GetPageTag()) == FALSE)
	{
		echo "Cette page n'existe pas encore, voulez-vous la <a href=\"".$this->href("edit").'" title="Formulaire pour cr&eacute;er le texte de cette page">cr&eacute;er</a> ?' ;
		$themeMgrObj = &$this->GetThemeManager();
		$themeMgrObj->addBodyClass('create');
	}
	else
	{
		// comment header?
		if ($this->page["comment_on"] && $this->GetConfigValue('comment_enable'))
		{
			echo "<div class=\"warning\">Ceci est un commentaire sur ",$this->ComposeLinkToPage($this->page["comment_on"], "", ""),", post&eacute; par ",$this->Format($this->page["user"])," &agrave; ",$this->page["time"],"</div>";
		}

		if ($this->page["latest"] == "N")
		{
			echo '<div class="warning">';
			echo "<p>Ceci est une version archiv&eacute;e de <a href=\"",$this->href(),"\">",$this->GetPageTag(),"</a> &agrave; ",$this->page["time"],".</p>";
			if ($this->HasAccess("write"))
			{	// the user can edit a previous version
				echo "<p>Vous pouvez la r&eacute;&eacute;diter en cliquant sur le bouton de r&eacute;&eacute;dition en bas de la page.</p>";
			}
			echo '</div>';
		}

		// Calcul du taux de remplissage de la page
		$PageSize = strlen($this->page["body"]) * 100 / $this->GetConfigValue("max_page_size");

		if ($PageSize > 80) {
			echo '<div class="warning">';
			echo "<p><b>Attention :</b> Les pages trop longues nuisent  la rapidit d'affichage et au confort de lecture. Nous vous conseillons de la racourcir ou de la scinder en plusieurs pages.</p>";
			echo '</div>';
		}

		// display page
		$this->RegisterInclusion($this->GetPageTag());
		echo "\t".$this->Format($this->page["body"], "wakka");
		$this->UnregisterLastInclusion();

		// if this is an old revision, display some buttons
		if (($this->page["latest"] == "N") && $this->HasAccess("write"))
		{
			$latest = $this->LoadPage($this->GetPageTag());
			?>
			<?php echo  $this->FormOpen("edit") ?>
			<input type="hidden" name="previous" value="<?php echo  $latest["id"] ?>" />
			<input type="hidden" name="body" value="<?php echo  htmlentities($this->page["body"]) ?>" />
			<input type="submit" value="R&eacute;&eacute;diter cette version archiv&eacute;e" />
			<?php echo  $this->FormClose(); ?>
			<?php
		}
	}
}
else
{
	echo "<div class=\"error\">Vous n'&ecirc;tes pas autoris&eacute; &agrave; lire cette page</div>" ;
}
?>

</div></div>

<div id="copyright">
<?php
	// display copyright text only if not empty
	if (strlen($this->GetConfigValue("meta_copyright")))
		echo '<p>Texte sous licence <a href="'.$this->href('', 'SiteCopyright').'">'.htmlentities($this->GetConfigValue("meta_copyright")).'</a></p>';
?>
</div>

<?php
if ($HasAccessRead && (!$this->page || !$this->page["comment_on"]) && $this->GetConfigValue('comment_enable'))
{
	// load comments for this page
	$comments = $this->LoadComments($this->GetPageTag());
	
	// store comments display in session
	$tag = $this->GetPageTag();
	if (!isset($_SESSION["show_comments"][$tag]))
		$_SESSION["show_comments"][$tag] = ($this->UserWantsComments() ? "1" : "0");
	if (isset($_REQUEST["show_comments"])){	
		switch($_REQUEST["show_comments"])
		{
		case "0":
			$_SESSION["show_comments"][$tag] = 0;
			break;
		case "1":
			$_SESSION["show_comments"][$tag] = 1;
			break;
		}
	}
	// display comments!
	if ($this->page && $_SESSION["show_comments"][$tag])
	{
		// display comments header
?>

<div id="comments"><div class="deco-body">
	<div class="box-top">
		<h1><a name="go_Page_Comments"></a>Commentaires</h1>
		<ul>
			<li><a href="<?php echo  $this->href("", "", "show_comments=0") ?>">Cacher les commentaires et le formulaire</a></li>
		</ul>
	</div>

<?php
		
		// display comment form
		if ($this->HasAccess("comment"))
		{
			echo "\t".$this->FormOpen("addcomment");
			echo "\t\t<label for=\"commentbody\">Ajouter un commentaire &agrave; cette page</label>\n";
			echo "\t\t<textarea id=\"commentbody\" name=\"body\" rows=\"6\" cols=\"65\" title=\"Entrez le texte de votre commentaire ici\"></textarea>\n";
			echo "\t\t<input type=\"submit\" value=\"Ajouter\" accesskey=\"s\" />\n";
			echo "\t".$this->FormClose();
		}
		else
		{
			echo "<div class=\"warning\">\n<p>D&eacute;sol&eacute;, vous n'avez pas l'autorisation d'ajouter des commentaires sur cette page.</p>\n</div>\n";
		}

		// display comments themselves
		if ($comments)
		{
			$odd_even = True;
			foreach ($comments as $comment)
			{
				$odd_even = !$odd_even;
				$owner_link = '<li class="owner"><a href="' . $this->href('',$comment["user"]) . '" title="Voir la page de ce contributeur">' . $comment["user"] . "</a></li>\n";
				$edit_link = '';
				$remove_link = '';
				if ($this->HasAccess('write', $comment['tag'])
				 || $this->UserIsOwner($comment['tag'])
				 || $this->UserIsAdmin($comment['tag']))
				{
					if ($this->HasAccess('write', $comment['tag']))
					{
						$edit_link = '<li class="edit"><a href="'.$this->href('edit',$comment['tag']).'" title="Formulaire pour modifier ce commentaire">&Eacute;diter</a></li>'."\n";
					}
					if ($this->UserIsOwner($comment['tag'])
					 || $this->UserIsAdmin($comment['tag']))
					{
						$remove_link = '<li class="remove"><a href="'.$this->href('deletepage',$comment['tag']).'" title="Supprimer d&eacute;finitivement ce commentaire, sans confirmation">Supprimer</a></li>'."\n";
					}
				}
?>
	<div class="<?php echo ($odd_even % 2) ? 'even' : 'odd' ?>">
		<a name="<?php echo $comment["tag"] ?>"></a>
		<ul class="box-top">
			<?php echo $owner_link ?>
			<li class="date"><?php echo $comment["time"] ?></li>
			<?php echo $edit_link ?>
			<?php echo $remove_link ?>
</ul>
		
		<div class="box-body">
			<?php echo $this->Format($comment["body"]),"\n" ?>
		</div>
	</div>

<?php
			}
		}

		echo "</div></div>\n";
	}
}

$content = ob_get_clean();
echo $this->Header();
echo $content;
echo $this->Footer();

?>
