<?php
/*
Copyright 2007,  Xavier GARREAU

All rights reserved.
Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:
1. Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.
3. The name of the author may not be used to endorse or promote products
derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

class base_mysql {
	/*******************************************************************/
	/***          La configuration par dfaut est ici ;)             ***/
	/*******************************************************************/
	/***/ var $host	= "localhost";	// voir hbergeur		        /***/
	/***/ var $user	= "";	// vide ou "root" en local	            /***/
	/***/ var $pass	= "";	// vide en local		                /***/
	/***/ var $bdd	= "";	// nom de la BD			                /***/
	/*******************************************************************/

	var $link;
	var $nbReqs;
		
	function base_mysql () {
		$this->link = NULL;
		$this->nbReqs = 0;
	}
	
	function query ($str) {
		if (!$this->link) {
			$this->link = @mysql_connect($this->host,$this->user,$this->pass);
			if ($this->link) {
				if (!@mysql_select_db($this->bdd, $this->link)) {
					$this->link = NULL;
				}
			}
		}
		if ($this->link) {
    		++$this->nbReqs;
    		return @mysql_query ($str, $this->link);
		} else {
            return NULL;
        }
	}

	function unbuffered_query ($str) {
		if (!$this->link) {
			$this->link = @mysql_connect($this->host,$this->user,$this->pass);
			if ($this->link) {
				if (!@mysql_select_db($this->bdd, $this->link)) {
					$this->link = NULL;
				}
			}
		}
		if ($this->link) {
    		++$this->nbReqs;
    		return @mysql_unbuffered_query ($str, $this->link);
		} else {
            return NULL;
        }
	}

	function fetch_assoc($results) {
		return @mysql_fetch_array ($results);
	}

	function fetch_object($results) {
		return @mysql_fetch_object ($results);
	}

	function free_result($results) {
		return @mysql_free_result ($results);
	}

	function escape_string($str) {
		return @mysql_escape_string ($str);
	}

	function close() {
		return @mysql_close ($this->link);
	}

	function num_rows($results) {
		return @mysql_num_rows ($results);
	}

	function error_string () {
		if (!$this->lien) {
			return @mysql_error ($this->link);
		}
	}
	
	function substr_name () {
	   // substr n'existe qu' partir de MySQL-4.1
	   return 'substring';
    } 
}

class base_sqlite {
	/*******************************************************************/
	/***              La configuration SQLite est ici ;)             ***/
	/*******************************************************************/
	/***/    var $dbpath = '';                                      /***/
	/*******************************************************************/

	var $link;
	var $nbReqs;

	function base_sqlite () {
		$this->link = NULL;
		$this->nbReqs = 0;
	}

	function query($str) {
		if (!$this->link) {
			$this->link = @sqlite_open($this->dbpath, 0666);
		}
		if ($this->link) {
    		++$this->nbReqs;
    		return sqlite_query ($str, $this->link, SQLITE_ASSOC);
    	} else {
            return NULL;
        } 
	}

	function unbuffered_query($str) {
		if (!$this->link) {
			$this->link = @sqlite_open($this->dbpath, 0666);
		}
		if ($this->link) {
    		++$this->nbReqs;
    		return sqlite_unbuffered_query ($str, $this->link, SQLITE_ASSOC);
    	} else {
            return NULL;
        } 
	}

	function fetch_assoc($results) {
		return @sqlite_fetch_array ($results);
	}

	function fetch_object($results) {
		$resul = @sqlite_fetch_array ( $results );
		if (!$resultat) {
			return NULL;
		}

		foreach ($result as $n => $v) {
			$object->$n = $v;
		}

		return $object;
	}

	function free_result($results) {
		return TRUE;
	}

	function escape_string($str) {
		return @sqlite_escape_string ($str);
	}

	function num_rows($results) {
		return @sqlite_num_rows ($results);
	}

	function close() {
		return @sqlite_close ($this->link);
	}

	function error_string () {
		if (!$this->link) {
			return @sqlite_error_string(sqlite_last_error ($this->link));
		}
	}
	
	function substr_name () {
	   return 'substr';
    } 
}

function database_constructor ($dbtype, $config) {
    $constructor = 'base_'.$dbtype;
    $dbObject = new $constructor();
    switch ($dbtype) {
        case 'mysql':
            $dbObject->host = $config['mysql_host'];
            $dbObject->user = $config['mysql_user'];
            $dbObject->pass = $config['mysql_password'];
            $dbObject->bdd = $config['mysql_database'];
            break;
        case 'sqlite':
            $dbObject->dbpath = $config['sqlite_dbpath'];
            break;
    }
    return $dbObject;
}
?>
