<?php
/* header.php
Copyright (c) 2002, Hendrik Mans <hendrik@mans.de>
Copyright 2002, 2003 David DELON
Copyright 2002, 2003, 2004, 2006 Charles NEPOTE
Copyright 2002  Patrick PAUL
Copyright 2003  Eric DELORD
Copyright 2004, 2006  Didier LOISEAU
Copyright 2006  Jean-Michel PHILIPPE
All rights reserved.
Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:
1. Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.
3. The name of the author may not be used to endorse or promote products
derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

// contants that should become conf params one day...
$encoding = 'iso-8859-15';
$lang = 'fr';

// Page info
$page_name = $this->GetPageTag();
$page_addr = $this->href();
$site_url = $this->GetConfigValue("base_url");

// <head> : additional metas if required or not empty
$additionnal_metas = '';
if ($this->GetMethod() != 'show'
	|| !empty($_REQUEST['phrase'])
	|| !empty($_REQUEST['show_comments'])
	|| isset($_REQUEST['time']))
{
	$additionnal_metas = "\t<meta name=\"robots\" content=\"noindex, nofollow\" />\n";
}
$meta_author = htmlentities($this->GetConfigValue("meta_author"));
if (strlen($meta_author))
	$additionnal_metas .= "\t<meta name=\"author\" content=\"$meta_author\" />\n";
$meta_keywords = htmlentities($this->GetConfigValue("meta_keywords"));
if (strlen($meta_keywords))
	$additionnal_metas .= "\t<meta name=\"keywords\" content=\"$meta_keywords\" />\n";
$meta_description = htmlentities($this->GetConfigValue("meta_description"));
if (strlen($meta_description))
	$additionnal_metas .= "\t<meta name=\"description\" content=\"$meta_description\" />\n";
$meta_copyright = htmlentities($this->GetConfigValue("meta_copyright"));
if (strlen($meta_copyright))
	$additionnal_metas .= "\t<meta name=\"copyright\" content=\"$meta_copyright\" />\n";

// themes
$thm_manager = &$this->GetThemeManager();
if (isset($_COOKIE['sitestyle']))
{
    $thm_manager->setUserTheme($_COOKIE['sitestyle']);
}
$imports = $thm_manager->generateImports($this->method);
$IEFixes = $thm_manager->generateIETricks();

// Page contents
$body_attr = ($message = $this->GetMessage()) ? " onload=\"alert('".addslashes($message)."');\" " : "";
$body_classes = $thm_manager->getBodyClass();
$wiki_name = $this->GetWakkaName();
$root_page_url = $this->href('', $this->GetConfigValue("root_page"));

// Page menu
$edit_link = '';
$delete_link = '';
$owner_link = '';
if ($this->GetMethod() != "edit")
{
	if ($this->HasAccess("write"))
	{
		if ($this->page)
		{	// if this page exists
			$edit_link = '<li class="edit"><a href="'.$this->href("edit").'#go_Page_Title" title="Formulaire pour modifier le texte de cette page">&Eacute;diter cette page</a></li>'."\n";
		}
		else
		{
			$edit_link = '<li class="edit"><a href="'.$this->href("edit").'#go_Page_Title" title="Formulaire pour entrer le texte de cette page">Cr&eacute;er cette page</a></li>'."\n";
		}
	}
	else
	{
		$edit_link = '<li class="locked" title="Vous ne pouvez pas modifier cette page"><dfn>Page verrouill&eacute;e</dfn></li>'."\n";
	}
}
else
{
	$edit_link = '<li class="edit">&Eacute;dition de la page</li>'."\n";
}
if ($this->page)
{	// if this page exists
	if ($this->UserIsOwner())
	{	// owner is current user
		$delete_link = "<li class=\"remove\"><a href=\"" . $this->href("deletepage") . "\" title=\"Supprimer d&eacute;finitivement cette page\">Supprimer cette page</a></li>\n";
		$owner_link = '<li class="owner">Page g&eacute;r&eacute;e par vous</li>'."\n";
	}
	else
	{
		if ($owner = $this->GetPageOwner())
		{	// owner is not the user
			$owner_link = '<li class="owner">Page g&eacute;r&eacute;e par <a href="'.$this->href("", $owner).'" title="Voir la page de ce contributeur">' . $owner . '</a></li>'."\n";
		}
		else
		{	// page has no owner
			if ($this->GetUser())
			{	// user has authentified
				$owner_link = '<li class="owner"><a href="' . $this->href("claim") . '" title="Devenir le gestionnaire de cette page">Appropriation</a></li>'."\n";
			}
			else
			{	// anonymous user
				$owner_link = '<li class="owner"><dfn title="Cette page n\'est g&eacute;r&eacute;e par aucun contributeur du site">Pas de gestionnaire</dfn></li>'."\n";
			}
		}
	}
}
$date_link = (strlen($this->GetPageTime())) ? '<li class="date" title="Date de la derni&egrave;re modification">' . $this->GetPageTime() . "</li>\n" : '';

?>
<?php echo "<?xml version=\"1.0\" encoding=\"$encoding\"?>\n" ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="<?php echo $lang ?>" xml:lang="<?php echo $lang ?>">

<head>
	<title><?php echo "$wiki_name:$page_name" ?></title>
	<meta http-equiv="Content-Type" content="text/html; charset=<?php echo $encoding ?>"/>
	<meta http-equiv="Content-Language" content="<?php echo $lang ?>" />
	<meta name="generator" content="Wikini" />
<?php echo $additionnal_metas ?>

	<!-- <link rel="shortcut icon" href="favicon.ico" type="image/x-icon" />
	<link rel="alternate" type="application/rss+xml" title="<?php echo $wiki_name ?> - fil des pages modifi&eacute;es" href="<?php echo $site_url ?>PageRSS/xml" />
	<link rel="alternate" type="application/rss+xml" title="<?php echo $wiki_name ?> - fil des commentaires ajout&eacute;s" href="<?php echo $site_url ?>CommentRSS/xml" />
	<link rel="alternate" type="application/rss+xml" title="<?php echo $wiki_name ?> - fil de la page <?php echo $page_name ?>" href="<?php echo $page_addr ?>/xml" /> -->

	<style type="text/css" media="all">
		<!--
<?php echo $imports ?>
		//-->
	</style>
<?php echo $IEFixes ?>
	<!--[if lt IE 7]>
		<style type="text/css" media="screen" />
			pre.code {	/* max-height emulation */
				height: expression(this.scrollHeight > 400? "400px" : "auto" );
			}
		</style>
	<![endif]-->

<script type="text/javascript"><?php echo "<!--\n"; include(WIKINI_INCLUDE_PATH . "js/fonctions.js"); echo "\n//-->"; ?></script>
</head>

<body class="<?php echo $body_classes ?>"<?php echo $body_attr ?>>
<div id="container"><div class="deco-body">

<div id="header">
	<div class="box-top">
    		<h1>
			<a href="<?php echo $root_page_url ?>" title="Retourner &agrave; la page d'accueil"><!--<img src="../images/logo.png" alt="logo du site" />--><?php echo $wiki_name ?></a>
		</h1>
	</div>
	
	<div class="box-body">
		<?php echo (strlen($meta_description)) ? "<p>$meta_description</p>" : '' ?>
		<a style="display: none;" href="<?php echo $page_addr ?>/resetstyle" accesskey="7">Pas de style</a>
	</div>
</div>

<div id="page"><div class="deco-body">
<div id="title">
	<div>
		<h1><a id="go_Page_Title"></a> <?php echo $page_name ?> </h1>
	</div>
	<ul>
		<?php echo $edit_link ?>
		<!--<li class="page-rss">
			<a href="#" title="Lien vers le fil de cette page">Suivre cette page</a>
		</li>-->
		<?php echo $date_link ?>
		<?php echo $owner_link ?>
		<?php echo $delete_link ?>
</ul>
</div>
