<?php
/*
default.php

Copyright 2002, Hendrik Mans <hendrik@mans.de>
Copyright 2002, 2003, David DELON
Copyright 2002, Patrick PAUL
Copyright 2006, Stphane Aulery
Copyright 2007, Xavier GARREAU

All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:
1. Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.
3. The name of the author may not be used to endorse or promote products
derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

if (!defined('WIKINI_VERSION'))
{
	die ("acc&egrave;s direct interdit");
}
?>

<h1>Installation de WikiNi</h1>

<?php
if (($wakkaConfig["wakka_version"]) || ($wakkaConfig["wikini_version"]))
{
	if ($wakkaConfig["wikini_version"]) {
		$config=$wakkaConfig["wikini_version"];
	}
	else {
		$config=$wakkaConfig["wakka_version"];
	}
	echo "<p>Votre syst&egrave;me WikiNi existant a &eacute;t&eacute;",
		" reconnu comme &eacute;tant la version ",$config,". Vous &ecirc;tes sur le point ",
		"de <b>mettre &agrave; jour</b> WikiNi pour la version ",WIKINI_VERSION,
		". Veuillez revoir vos informations de configuration ci-dessous.</p>\n";

	echo "<p>NOTE : Ce programme d'installation va essayer de modifier les options de configuration dans le fichier <tt>wakka.config.php</tt>, situ&eacute; dans votre r&eacute;pertoire WikiNi. Pour que cela fonctionne, veuillez vous assurer que votre serveur
a les droits d'acc&egrave;s en &eacute;criture pour ce fichier. Si vous ne pouvez pas faire &ccedil;a vous devrez modifier ce fichier manuellement selon les indications qui suivront.</p>";
}
else
{
	echo "<p>Vous &ecirc;tes sur le point d'installer WikiNi ",WIKINI_VERSION,
		" pour la premire fois. Veuillez configurer votre WikiNi en utilisant le formulaire suivant.</p>\n";

	echo "<p>NOTE : Ce programme d'installation va essayer de cr&eacute;er le fichier de configuration <tt>wakka.config.php</tt>, situ&eacute; dans votre r&eacute;pertoire WikiNi. Pour que cela fonctionne, veuillez vous assurer que votre serveur
a les droits d'acc&egrave;s en &eacute;criture sur le r&eacute;pertoire WikiNi. Si vous ne pouvez pas faire &ccedil;a vous devrez cr&eacute;er ce fichier manuellement selon les indications qui suivront.</p>";
}
?>

<h2>Configuration de la base de donn&eacute;es</h2>

<p>WikiNi a &eacute;t&eacute; d&eacute;velopp&eacute; pour fonctionner sur des serveur de base de donn&eacute;es MySQL. Indiquez les param&eacute;tre de votre serveur ci-dessous. En cas de doute, renseignez-vous aupr&egrave;s de votre hbergeur.</p>

<form action="<?php echo  myLocation() ?>?installAction=install" method="post">

	<fieldset>
		<label title="Type de base de donn&eacute;es">
			Type de base :
			<select name="config[dbtype]">
            <option value="mysql" <?php echo ($wakkaConfig['dbtype']=='mysql' ? 'selected="true"' : ''); ?>>MySQL</option>
            <option value="sqlite" <?php echo ($wakkaConfig['dbtype']=='sqlite' ? 'selected="true"' : ''); ?>>SQLite</option>
			</select>
		</label>
			<p>Si vous choisissez d'utiliser SQLite, vous n'avez pas besoin de remplir les champs spcifiques  MySQL ci-dessous.</p>

		<br/><br/>

		<label title="Adresse de votre serveur MySQL">
			H&ocirc;te MySQL :
			<input type="text" name="config[mysql_host]" value="<?php
			echo $wakkaConfig["mysql_host"] ?>" />
		</label>
			<p>En g&eacute;n&eacute;ral c'est "localhost" si vous installez WikiNi chez vous (en local). Sinon c'est le nom du serveur MySQL de votre h&eacute;bergeur.</p>

		<br/><br/>

		<label title="Nom de votre base de donnes">
			Nom de la Base :
			<input type="text" name="config[mysql_database]" value="<?php
			echo $wakkaConfig["mysql_database"] ?>" />
		</label>
			<p>Si vous n'avez pas les droits pour cr&eacute;er une nouvelle base, la base de donn&eacute;es indiqu&eacute;e doit d&eacute;j&agrave; exister avant de pouvoir continuer.</p>

		<br/><br/>

		<label>
			Non d'utilisateur :
			<input type="text" name="config[mysql_user]" value="<?php
			echo $wakkaConfig["mysql_user"] ?>" />
		</label>
		<label>
			Mot de passe :
			<input type="password" name="config[mysql_password]" value="" />
		</label>
			<p>Nom et mot de passe de l'utilisateur MySQL qui sera utilis&eacute;
		pour se connecter &agrave; votre base de donn&eacute;es.</p>

		<br/><br/>

		<label title="Prefixe  appliquer aux noms des tables">
			Prefixe des tables :
			<input type="text" name="config[table_prefix]" value="<?php
			echo $wakkaConfig["table_prefix"] ?>" />
		</label>
			<p>En p&eacute;fixant le nom des tables vous viterez de rencontrer des conflis avec d'autres CMS (DotClear, WordPress, ...) &agrave;. De plus en donnant diff&eacute;rents pr&eacute;fixes aux tables vous pouvez utiliser plusieurs WikiNi sur une m&ecirc;me base de donnn&eacute;es.</p>
	</fieldset>
			
<h2>Configuration de votre site WikiNi</h2>

	<fieldset>
		<label title="Nom de votre site WikiNi">
			Nom du site :
			<input type="text" name="config[wakka_name]" value="<?php
			echo $wakkaConfig["wakka_name"] ?>" />
		</label>
			<p>Ceci est g&eacute;n&eacute;ralement un NomWiki et EstSousCetteForme.</p>

		<br/><br/>

		<label title="Nom de la page d'accueil">
			Page d'accueil :
			<input type="text" name="config[root_page]" value="<?php
			echo $wakkaConfig["root_page"] ?>" />
		</label>
			<p>Ceci doit &ecirc;tre un NomWiki.</p>

		<br/><br/>

		<label title="Mots clefs pour le rfrencement des moteurs de recherche">
			Mots clefs :
			<input type="text" name="config[meta_keywords]" value="<?php
			echo $wakkaConfig["meta_keywords"] ?>" />
		</label>
			<p>META Mots clefs/Description qui seront ins&eacute;r&eacute;s dans les codes HTML.</p>

		<br/><br/>

		<label title="Courte phrase dcrivant votre site">
			Description :
			<input type="text" name="config[meta_description]" value="<?php
			echo $wakkaConfig["meta_description"] ?>" />
		</label>
	</fieldset>

<h2>Configuration de l'URL de votre WikiNi</h2>
<?php
if (!$wakkaConfig["wikini_version"]) {
	echo "<p>Le programme d'installation va essayer de dtecter l'URL appropri&eacute;. Changez-la uniquement si vous savez ce que vous faites.</p>";
}
?>

	<fieldset>
		<label title="Adresse de votre site">
			URL de base :
			<input type="text" name="config[base_url]" value="<?php
			echo $wakkaConfig["base_url"] ?>" />
		</label>
			<p>Les noms des pages seront directement rajout&eacute;s &agrave; cet URL.</p>
	</fieldset>

<h2>Options suppl&eacute;mentaires</h2>

<p>NB : Les URL se terminent obligatoirement par une barre. Les options qui suivent sont destines &agrave; des utilisateurs avertis. Si vous ne connaissez pas leur fonction, ne les modifiez pas ou renseignez-vous sur <a href="http://www.wikini.net/wakka.php?wiki=DocumentationAdministrateurTechnique">WikiniPointNet</a>.</p>

	<fieldset>
		<label>
			Rpertoire des actions :
			<input type="text" name="config[action_path]" value="<?php
            echo $wakkaConfig['action_path'] ?>" />
		</label>
			<p>Adresse du rpertoire regroupant les actions disponibles sur votre Wiki.</p>

		<br/><br/>

		<label>
			Rpertoire des formatters :
			<input type="text" name="config[formatter_path]" value="<?php
            echo $wakkaConfig['formatter_path'] ?>" />
		</label>
			<p>Adresse du rpertoire regroupant les formatters disponibles sur votre Wiki.</p>

		<br/><br/>

		<label>
			Rpertoire des handlers :
			<input type="text" name="config[handler_path]" value="<?php
            echo $wakkaConfig['handler_path'] ?>" />
		</label>
			<p>Adresse du rpertoire regroupant les handlers disponibles sur votre Wiki.</p>

		<br/><br/>

		<label>
			Rpertoire thmes :
			<input type="text" name="config[themes_dir_url]" value="<?php
            echo $wakkaConfig['themes_dir_url'] ?>" />
		</label>
			<p>Adresse du rpertoire regroupant tous les thmes disponibles pour les utilisateurs sur votre Wiki.</p>

		<br/><br/>

		<label>
			Taille maximale de page :
			<input type="text" name="config[max_page_size]" value="<?php
            echo $wakkaConfig['max_page_size'] ?>" />
		</label>
			<p>Cette option permet de choisir la taille  partir de laquelle l'utilisateur est alert qu'il dite une page trop longue. Son but est de prvenir les pertes de donnes et d'inciter l'utilisateur  la concision. La limite des<?php echo " ".WIKINI_MAX_BD_PAGE_SIZE." " ?>caractres ne peut tre dpasse.</p>
	</fieldset>

<p><input type="hidden" name="config[comment_enable]" value="0" />
	<input type="checkbox" name="config[comment_enable]" value="1" <?php
    echo $wakkaConfig["comment_enable"] ? "checked" : "" ?> /> Activer la gestion des commentaires</p>

<p>Le mode "gestion des commentaires" permet &acirc; vos visiteurs de laisser des commentaires sur vos pages. Si ce mode est d&eacute;sactiv&eacute;, il ne sera plus possible d'&eacute;crire ou de visualiser aucun commentaire sur l'ensemble de votre wiki. Il ne faut pas confondre cette option avec le droit de commenter qu'accord le propri&eacute;taire d'une page &acirc; ses lecteurs lorsque la "gestion des commentaires" est activ&eacute;e.</p>

<p><input type="hidden" name="config[rewrite_mode]" value="0" />
	<input type="checkbox" name="config[rewrite_mode]" value="1" <?php
    echo $wakkaConfig["rewrite_mode"] ? "checked" : "" ?> /> Activer le mode "redirection"</p>

<p>Le mode "redirection automatique" doit &ecirc;tre s&eacute;lectionn&eacute;
uniquement si vous utilisez WikiNi avec la redirection d'URL (si vous ne savez pas
ce qu'est la redirection d'URL n'activez pas cette option).</p>

<p><input type="hidden" name="config[preview_before_save]" value="0" />
	<input type="checkbox" name="config[preview_before_save]" value="1" <?php
		echo $wakkaConfig["preview_before_save"] ? "checked" : "" ?> />
		Imposer de faire un aper&ccedil;u avant de pouvoir sauver une page.</p>
		
<p><input type="checkbox" name="config[allow_raw_html]" value="1" <?php
	echo $wakkaConfig['allow_raw_html'] ? 'checked' : '' ?> />
	Autoriser l'insertion de HTML brut.
	<span style="color: red; font-weight: bold">! Attention !</span>
	Ceci peut prsenter une vritable faille de scurit ! Ne cochez pas cette case
	si vous ne savez pas ce que vous faites.</p>

        <p><br/><br/><input type="submit" value="Continuer" /></p>
</form>
