<?php
/*
header.php

Copyright 2002, Hendrik Mans <hendrik@mans.de>
Copyright 2002, 2003, David DELON
Copyright 2002, Patrick PAUL
Copyright 2006, Charles NEPOTE
Copyright 2006, Stphane Aulery

All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:
1. Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.
3. The name of the author may not be used to endorse or promote products
derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

// stuff
if (!defined('WIKINI_VERSION'))
{
	die ("acc&egrave;s direct interdit");
}

require 'includes/constants.php';

/**
 * Communique le rsultat d'un test :
 * -- affiche OK si elle l'est
 * -- affiche un message d'erreur dans le cas contraire
 * 
 * @param string $text Label du test
 * @param boolean $condition Rsultat de la condition teste
 * @param string $errortext Message en cas d'erreur
 * @param string $stopOnError Si positionne  1 (par dfaut), termine le
 *               script si la condition n'est pas vrifie 
 * @return int 0 si la condition est vraie et 1 si elle est fausse
 */
function test($text, $condition, $errorText = "", $stopOnError = 1)
{
	echo "<p>".$text." ";
	if ($condition)
	{
		echo "<span class=\"ok\">OK</span></p>\n";
		return 0;
	}
	else
	{
		echo "<span class=\"failed\">ECHEC</span>";
		if ($errorText) echo ": ",$errorText;
		echo "</p>\n";
		if ($stopOnError)
		{
			echo "L'installation a choue. <a href='javascript:window.back()'>Retourner &agrave; la page pr&eacute;c&eacute;dente</a> pour modifier les param&eacute;tres qui peuvent &ecirc;tre en cause.</p>\n";
			echo "</body>\n</html>\n";
			exit;
		}
		return 1;
	}
}

function myLocation()
{
	list($url, ) = explode("?", $_SERVER["REQUEST_URI"]);
	return $url;
}

ob_start();
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
   "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" lang="fr" xml:lang="fr">
<head>
  <title>Installation de WikiNi</title>
  <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"/>
  <style type="text/css">

body {
	font: normal 88% "Bitstream Vera Sans", verdana, sans-serif;
	line-height: 160%;
}

body, div, form, fieldset {
	margin: 0px;
	padding: 0px;
}

p {
	margin: 0.5em 0;
}

a {
	text-decoration: none;
	color: #87492f;
	background: #fff;
}

a:hover {
	text-decoration: underline;
	color: #c05f2f;
	background: #fff;
}

br {
	display: block;
	margin: 0.5em;
}

body, p, input, select, textarea {
	font-family: Verdana, Geneva, Arial, Helvetica, sans-serif;
	font-size: 13px;
}

.ok { 
	color: #080;
	background: #fff;
	font-weight: bold;
}

.failed {
	color: #800;
	background: #fff;
	font-weight: bold;
}

.code {
	background-color: #eee;
	padding: 2px 10px;
}

fieldset {
	border-width: 0;
}

/******* global page layout ******/
body {
	color: white;
	background: #708090;
	text-align: center;		/* centers div#container in non-compliant browsers */
}

div#container {
	position: relative;
	width: 48em;		/* change width and margin: auto to % for a liquid design (adaptive width) */
	margin: 0 auto;
	text-align: left;
	color: black;
	background-color: white;
	padding: 20px;
}


h1 {
	margin: 0;
	padding: 10px 0 0 0;	/* parent div padding symetry */
	color: #1f497f;
	background: #fff;
	font-size: 1.5em;
	line-height: 120%;
}

h2 {
	padding: 10px 0 0 0;	/* parent div padding symetry */
	color: #7e4934;
	background: #fff;
	font: bold 1.25em "Trebuchet MS", Georgia, serif;
	letter-spacing: 2px;
}

fieldset {
	margin: 1em 0;
	padding: 1em 0.5em;
	text-align: center;
	color: #000;
	background: #fafafa;
	border: 1px solid #bbb;
}

legend {
	color: #7e4934;
	background: #fff;
	font: bold 1.25em "Trebuchet MS", Georgia, serif;
	letter-spacing: 2px;
}

label {
	display: block;
	position: relative;
	width: 18em;			/* left column width */
	margin: 0.5em 0;
	text-align: left;
	font-weight: bold;
}
label input {
	display: block;
	position: absolute;
	top: 0;
	left: 15em;
	width: 15em;			/* right column width */
	text-align: left;
	color: #800;
	background: #fff;
}

div.warning,
div.error {
	min-height: 38px;
	margin: 1em 0;
	padding: 10px 1em 10px 70px;
	background: #f3f5f7 url("setup/images/icon-warning.png") 10px 50% no-repeat;
	border: 1px solid #bfc5d9;
}

</style>
</head>
<body>
<div id="container">
