<?php
/*
install.php

Copyright 2002, Hendrik Mans <hendrik@mans.de>
Copyright 2002, 2003, David DELON
Copyright 2002, 2003, Patrick PAUL
Copyright 2003,  Eric FELDSTEIN
Copyright 2006, Stphane Aulery
Copyright 2007, Xavier GARREAU

All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:
1. Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.
3. The name of the author may not be used to endorse or promote products
derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
if (!defined('WIKINI_VERSION'))
{
	die ("acc&egrave;s direct interdit");
}

require_once('tools.php');

echo "<h1>Installation de WikiNi</h1>\n";

if (empty($_POST['config'])) {
	header('Location: ' . myLocation());
	die ('probl&egrave;me dans la proc&eacute;dure d\'installation');
}

// fetch configuration
$config = $config2 = $_POST["config"];

// merge existing (or default) configuration with new one
$config = array_merge($wakkaConfig, $config);

// test configuration
echo "<h2>Test de la configuration</h2>\n";

if ($config['dbtype'] == 'mysql' && function_exists ('mysql_connect')) {
    test("Test connexion MySQL ...",
        $dblink = @mysql_connect($config["mysql_host"], $config["mysql_user"], $config["mysql_password"]));
    $testdb = test("Recherche base de donn&eacute;es ...",
    	@mysql_select_db($config["mysql_database"], $dblink),
    	"La base de donn&eacute;es que vous avez choisie n'existe pas. Nous allons tenter de la cr&eacute;er...",
    	0);
    	
    if($testdb == 1) {
    	test("Tentative de cr&eacute;ation de la base de donn&eacute;es...",
    		mysql_unbuffered_query("CREATE DATABASE ".$config["mysql_database"], $dblink),
    		"Cr&eacute;ation de la base impossible. Vous devez cr&eacute;er cette base manuellement avant d'installer WikiNi !");
    	test("Recherche base de donn&eacute;es ...",
    		@mysql_select_db($config["mysql_database"], $dblink),
    		"La base de donn&eacute;es que vous avez choisie n'existe pas, vous devez la cr&eacute;er avant d'installer WikiNi !",
    		1);
    }

    $dbObject = database_constructor ($config['dbtype'], $config);

} elseif ($config['dbtype'] == 'sqlite' && function_exists ('sqlite_open')) {
    $dbObject = database_constructor ($config['dbtype'], $config);
    test("Test connexion  la base de donnes ...",
    $dbObject->query('SELECT 0'),
    "La base de donn&eacute;es que vous avez choisie n'existe pas, vous devez la cr&eacute;er avant d'installer WikiNi !",
    1);

} else {
    die ("Aucun support de base de donnes compatible n'est disponible");
}


// do installation stuff
if (!$version = trim($wakkaConfig["wikini_version"])) $version = "0";
switch ($version)
{
// new installation
case "0":
	echo "<h2>Installation</h2>\n";

    switch ($config['dbtype']) {
        case "sqlite" : {
            $requete = "CREATE TABLE ".$config["table_prefix"]."pages (
                            id INTEGER NOT NULL PRIMARY KEY,
                            tag varchar(50) NOT NULL default '',
                            time datetime NOT NULL default '0000-00-00 00:00:00',
                            body text NOT NULL default '',
                            body_r text NOT NULL default '',
                            owner varchar(50) NOT NULL default '',
                            user varchar(50) NOT NULL default '',
                            latest varchar(1) NOT NULL default 'N',
                            comment_on varchar(50) NOT NULL default '' );
                        CREATE INDEX ".$config["table_prefix"]."pages_idx_tag ON ".$config["table_prefix"]."pages (tag);
                        CREATE INDEX ".$config["table_prefix"]."pages_idx_time ON ".$config["table_prefix"]."pages (time);
                        CREATE INDEX ".$config["table_prefix"]."pages_idx_latest ON ".$config["table_prefix"]."pages (latest);
                        CREATE INDEX ".$config["table_prefix"]."pages_idx_comment_on ON ".$config["table_prefix"]."pages (comment_on);
                        CREATE INDEX ".$config["table_prefix"]."pages_tag ON ".$config["table_prefix"]."pages (tag,body);";
        	break;
        }
        case "mysql" : {
            $requete =  "CREATE TABLE ".$config["table_prefix"]."pages (".
              			"id int(10) unsigned NOT NULL auto_increment,".
              			"tag varchar(50) NOT NULL default '',".
              			"time datetime NOT NULL default '0000-00-00 00:00:00',".
            			"body text NOT NULL,".
            			"body_r text NOT NULL,".
              			"owner varchar(50) NOT NULL default '',".
              			"user varchar(50) NOT NULL default '',".
              			"latest enum('Y','N') NOT NULL default 'N',".
              			"comment_on varchar(50) NOT NULL default '',".
              			"PRIMARY KEY  (id),".
              			"FULLTEXT KEY tag (tag,body),".
              			"KEY idx_tag (tag),".
              			"KEY idx_time (time),".
              			"KEY idx_latest (latest),".
              			"KEY idx_comment_on (comment_on)".
            			") TYPE=MyISAM;";
        	break;
        }
    }

 	test("Creation table page...",
		$dbObject->unbuffered_query($requete), "D&eacute;j&agrave; cr&eacute;&eacute;e ?", 0);
 
 
    switch ($config['dbtype']) {
        case "sqlite" : {
            $requete = "CREATE TABLE ".$config["table_prefix"]."acls (
                            page_tag varchar(50) NOT NULL default '',
                            privilege varchar(20) NOT NULL default '',
                            list text NOT NULL default '');
                        CREATE UNIQUE INDEX ".$config["table_prefix"]."acls_ ON ".$config["table_prefix"]."acls (page_tag,privilege);";
        	break;
        }
        case "mysql" : {
            $requete =  "CREATE TABLE ".$config["table_prefix"]."acls (".
              			"page_tag varchar(50) NOT NULL default '',".
            			"privilege varchar(20) NOT NULL default '',".
              			"list text NOT NULL,".
             			"PRIMARY KEY  (page_tag,privilege)".
            			") TYPE=MyISAM";
        	break;
        }
    }
    
 	test("Creation table ACL ...",
		$dbObject->unbuffered_query($requete), "D&eacute;j&agrave; cr&eacute;&eacute;e ?", 0);
 

    switch ($config['dbtype']) {
        case "sqlite" : {
            $requete = "CREATE TABLE ".$config["table_prefix"]."links (
                            from_tag char(50) NOT NULL default '' ,
                            to_tag char(50) NOT NULL default '' );
                        CREATE UNIQUE INDEX ".$config["table_prefix"]."links_from_tag ON ".$config["table_prefix"]."links (from_tag,to_tag);
                        CREATE INDEX ".$config["table_prefix"]."links_idx_from ON ".$config["table_prefix"]."links (from_tag);
                        CREATE INDEX ".$config["table_prefix"]."links_idx_to ON ".$config["table_prefix"]."links (to_tag);";
            break;
        }
        case "mysql" : {
            $requete = "CREATE TABLE ".$config["table_prefix"]."links (".
            		   "from_tag char(50) NOT NULL default '',".
              		   "to_tag char(50) NOT NULL default '',".
              		   "UNIQUE KEY from_tag (from_tag,to_tag),".
              		   "KEY idx_from (from_tag),".
              		   "KEY idx_to (to_tag)".
            		   ") TYPE=MyISAM";
            break;
        }
    }
    
 	test("Creation table link ...",
		$dbObject->unbuffered_query($requete), "D&eacute;j&agrave; cr&eacute;&eacute;e ?", 0);
 
 
    switch ($config['dbtype']) {
        case "sqlite" : {
            $requete = "CREATE TABLE ".$config["table_prefix"]."referrers (
                            page_tag char(50) NOT NULL default '',
                            referrer char(150) NOT NULL default '',
                            time datetime NOT NULL default '0000-00-00 00:00:00');
                        CREATE INDEX ".$config["table_prefix"]."referrers_idx_page_tag ON ".$config["table_prefix"]."referrers (page_tag);
                        CREATE INDEX ".$config["table_prefix"]."referrers_idx_time ON ".$config["table_prefix"]."referrers (time);";
            break;
        }
        case "mysql" : {
            $requete =  "CREATE TABLE ".$config["table_prefix"]."referrers (".
              			"page_tag char(50) NOT NULL default '',".
              			"referrer char(150) NOT NULL default '',".
              			"time datetime NOT NULL default '0000-00-00 00:00:00',".
              			"KEY idx_page_tag (page_tag),".
              			"KEY idx_time (time)".
            			") TYPE=MyISAM";
            break;
        }
    }

 	test("Creation table referrer ...",
		$dbObject->unbuffered_query($requete, $dblink), "D&eacute;j&agrave; cr&eacute;&eacute;e ?", 0);
 
 
    switch ($config['dbtype']) {
        case "sqlite" : {
            $requete = "CREATE TABLE ".$config["table_prefix"]."users (
                            name varchar(80) NOT NULL default '' PRIMARY KEY,
                            password varchar(32) NOT NULL default '' ,
                            email varchar(50) NOT NULL default '',
                            motto text NOT NULL default '',
                            revisioncount int(10) NOT NULL default '20' ,
                            changescount int(10) NOT NULL default '50' ,
                            doubleclickedit varchar(1) NOT NULL default 'Y' ,
                            signuptime datetime NOT NULL default '0000-00-00 00:00:00' ,
                            show_comments varchar(1) NOT NULL default 'N' );
                        CREATE INDEX ".$config["table_prefix"]."users_idx_name ON ".$config["table_prefix"]."users (name);
                        CREATE INDEX ".$config["table_prefix"]."users_idx_signuptime ON ".$config["table_prefix"]."users (signuptime);";
            break;
        }
        case "mysql" : {
            $requete =  "CREATE TABLE ".$config["table_prefix"]."users (".
              			"name varchar(80) NOT NULL default '',".
              			"password varchar(32) NOT NULL default '',".
              			"email varchar(50) NOT NULL default '',".
              			"motto text NOT NULL,".
              			"revisioncount int(10) unsigned NOT NULL default '20',".
              			"changescount int(10) unsigned NOT NULL default '50',".
              			"doubleclickedit enum('Y','N') NOT NULL default 'Y',".
              			"signuptime datetime NOT NULL default '0000-00-00 00:00:00',".
              			"show_comments enum('Y','N') NOT NULL default 'N',".
              			"PRIMARY KEY  (name),".
              			"KEY idx_name (name),".
              			"KEY idx_signuptime (signuptime)".
            			") TYPE=MyISAM";
            break;
        }
    }

 	test("Creation table user ...",
		$dbObject->unbuffered_query($requete, $dblink), "D&eacute;j&agrave; cr&eacute;&eacute;e ?", 0);
 
 
    switch ($config['dbtype']) {
        case "sqlite" : {
            $requete = "CREATE TABLE ".$config["table_prefix"]."triples (
                            id INTEGER NOT NULL PRIMARY KEY,
                            resource varchar(255) NOT NULL default '' ,
                            property varchar(255) NOT NULL default '' ,
                            value varchar(255) NOT NULL default '' );
                        CREATE INDEX ".$config["table_prefix"]."triples_resource ON ".$config["table_prefix"]."triples (resource);
                        CREATE INDEX ".$config["table_prefix"]."triples_property ON ".$config["table_prefix"]."triples (property);";
            break;
        }
        case "mysql" : {
            $requete = 'CREATE TABLE `' .$config['table_prefix'] . 'triples` (' .
			'  `id` int(10) unsigned NOT NULL auto_increment,' .
			'  `resource` varchar(255) NOT NULL default \'\',' .
			'  `property` varchar(255) NOT NULL default \'\',' .
			'  `value` varchar(255) NOT NULL default \'\',' .
			'  PRIMARY KEY  (`id`),' .
			'  KEY `resource` (`resource`),' .
			'  KEY `property` (`property`)' .
			') TYPE=MyISAM';
            break;
        }
    }

 	test("Creation table triplets ...",
		$dbObject->unbuffered_query($requete, $dblink), "D&eacute;j&agrave; cr&eacute;&eacute;e ?", 0);


	//insertion des pages de documentation et des pages standards 
	$d = dir("setup/doc/");
	while ($doc = $d->read()) {
		if ($doc != "." && $doc != ".." && !is_dir($doc)) {
			$pagecontent = implode ('', file("setup/doc/$doc"));
			if ($doc=='_root_page.txt'){
				$pagename = $config["root_page"];
			}else{
				$pagename = substr($doc,0,strpos($doc,'.txt'));
			}

			$sql = "Select tag from ".$config["table_prefix"]."pages where tag='$pagename'";

			if (($r=$dbObject->query($sql, $dblink)) && ($dbObject->num_rows($r)==0)) {
				$sql = "INSERT INTO ".$config["table_prefix"]."pages (tag, body, user, time, latest) ".
				"VALUES ('$pagename', ".
				"'".$dbObject->escape_string($pagecontent)."', ".
				"'WikiNiInstaller', ".
				"'".date('Y-m-d H:i:s')."', ".
				"'Y');";
 
				test("Insertion de la page $pagename ...", $dbObject->unbuffered_query($sql, $dblink),"?",0);

				WriteLinkTable($pagename, $pagecontent, $config["table_prefix"]);
			}
			else
			{
				test("Insertion de la page $pagename ...", 0 ,"Existe d&eacute;j&agrave;.",0);
			}	
		}
	}
	break;
	
	// The funny upgrading stuff. Make sure these are in order! //
case "0.1":
	echo "<b>En cours de mise &agrave; jour de WikiNi 0.1</b><br>\n";
	test("Modification trs lgre de la table des pages...", 
		$dbObject->unbuffered_query("alter table ".$config["table_prefix"]."pages add body_r text not null default '' after body", $dblink), "Already done? Hmm!", 0);
	// continue through the upgrading process to create the triple's table
case '0.4.0':
case '0.4.1':
case '0.4.2':
case '0.4.3':
case '0.4.4':
case '0.4.4-dev': // TODO remove this line (only for dev puproses)
case '0.5.0-dev': // TODO remove this line (idem)
case WIKINI_VERSION :

	test("Creation table triplets ...",
		$dbObject->unbuffered_query('CREATE TABLE ' .$config['table_prefix'] . 'triples (' . 
			'  id int(10) unsigned NOT NULL auto_increment,' . 
			'  resource varchar(255) NOT NULL default \'\',' . 
			'  property varchar(255) NOT NULL default \'\',' . 
			'  value varchar(255) NOT NULL default \'\',' . 
			'  PRIMARY KEY  (id),' . 
			'  KEY resource (resource),' . 
			'  KEY property (property)' . 
			') TYPE=MyISAM', $dblink), "D&eacute;j&agrave; cr&eacute;&eacute;e ?", 0);

	test("Suppression de champs obsoltes ...",
		$dbObject->unbuffered_query('ALTER TABLE ' .$config['table_prefix'] . 'pages ' .
			'  DROP COLUMN handler', $dblink), "Nettoyage d&eacute;j&agrave; op&eacute; ?", 0);
}

?>

<p>A l'&eacute;tape suivante, le programme d'installation va essayer
d'&eacute;crire le fichier de configuration <tt><?php echo WIKINI_CONFIG_PATH; ?></tt>.
Assurez vous que le serveur web a bien le droit d'&eacute;crire dans ce fichier, sinon vous devrez le modifier manuellement.</p>

<p>
<form action="<?php echo myLocation(); ?>?installAction=writeconfig" method="post">
<input type="hidden" name="config" value="<?php echo htmlentities(serialize($config)); ?>" />
<input type="submit" value="Continuer" />
</form>
</p>
