<?php
/*
$Id: wakka.php 740 2007-01-27 06:28:55Z lkppo $

Copyright (c) 2002, Hendrik Mans <hendrik@mans.de>
Copyright 2003 Carlo Zottmann
Copyright 2002, 2003, 2005 David DELON
Copyright 2002, 2003, 2004, 2006 Charles NPOTE
Copyright 2002, 2003 Patrick PAUL
Copyright 2003, Eric DELORD
Copyright 2003, Eric FELDSTEIN
Copyright 2004-2006, Jean-Christophe ANDR
Copyright 2005-2006, Didier LOISEAU
Copyright 2006, Stphane AULERY
Copyright 2007, Xavier GARREAU

All rights reserved.
Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:
1. Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.
3. The name of the author may not be used to endorse or promote products
derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

/*
    Yes, most of the formatting used in this file is HORRIBLY BAD STYLE. However,
    most of the action happens outside of this file, and I really wanted the code
    to look AS small AS what it does. Basically. Oh, I just suck. :)
*/

// stupid version check
if (!isset($_REQUEST)) die('$_REQUEST[] not found. Wakka requires PHP 4.1.0 or higher!');

// start the compute time
list($g_usec, $g_sec) = explode(" ", microtime());
define ("t_start", (float)$g_usec + (float)$g_sec);

// do not change this line, you fool. In fact, don't change anything! Ever!
include 'includes/constants.php';
include WIKINI_INCLUDE_PATH . 'urlutils.inc.php';
include WIKINI_INCLUDE_PATH . 'thememanager.class.php';
include WIKINI_INCLUDE_PATH . 'database.class.php';
include WIKINI_INCLUDE_PATH . 'wiki.class.php';
include WIKINI_INCLUDE_PATH . 'cachemanager.class.php';


set_magic_quotes_runtime(0);

if (get_magic_quotes_gpc()) {
	// workaround for the amazingly annoying magic quotes.
	function magicQuotesSuck(&$a) {
		if (is_array($a)) 	{
			foreach ($a as $k => $v) {
				if (is_array($v)) magicQuotesSuck($a[$k]);
				else $a[$k] = stripslashes($v);
			}
		}
	}

	magicQuotesSuck($_POST);
	magicQuotesSuck($_GET);
	magicQuotesSuck($_COOKIE);
}

// start session
session_start();

// Si la configuration n'a pas encore t charge
if (!isset($_SESSION['wikiconfig'])) {

	$_rewrite_mode = detectRewriteMode();

	// Default configuration values
	$wakkaDefaultConfig = array(
		'wakka_version'		=> '',
		'wikini_version'	=> '',
		'debug'			    => 'no',
		'dbtype'		    => 'mysql',
		'mysql_host'		=> 'localhost',
		'mysql_database'	=> 'wikini',
		'mysql_user'		=> 'wikini',
		'mysql_password'	=> '',
		'sqlite_dbpath'	    => 'db/wikini.db',
		'table_prefix'		=> 'wikini_',
		'root_page'		=> 'PagePrincipale',
		'wakka_name'		=> 'MonSiteWikiNi',
		'rewrite_mode'		=> $_rewrite_mode,
		'meta_keywords'		=> '',
		'meta_description'	=> '',
		'base_url'		=> computeBaseURL($_rewrite_mode),
		'action_path'		=> 'actions/',
		'handler_path'		=> 'handlers/',
		'formatter_path'	=> "formatters/",
		'themes_path'       	=> 'themes', // path in which are the themes, "physically"
		'themes_dir_url'    	=> getURLAbsolutePath() . 'themes/', // path in which are the themes for browser
		'navigation_links'	=> 'DerniersChangements :: DerniersCommentaires :: ParametresUtilisateur',
		'referrers_purge_time'	=> 24,
		'pages_purge_time'	=> 90,
		'default_write_acl'	=> '*',
		'default_read_acl'	=> '*',
		'default_comment_acl'	=> '*',
		'comment_enable'	=> TRUE,
		'preview_before_save'	=> 0,
		'allow_raw_html'	=> FALSE,
  		'max_page_size'		=> 65535);

	unset($_rewrite_mode);

	// Charge la configuration
	if (file_exists(WIKINI_CONFIG_PATH)) include(WIKINI_CONFIG_PATH);
	else $wakkaConfig= array();

	// Croise la configuration trouve avec la configuration par dfaut
	$wakkaConfig = array_merge($wakkaDefaultConfig, $wakkaConfig);

	$_SESSION['wikiconfig'] = $wakkaConfig;

	// Compare versions
	if ($wakkaConfig["wakka_version"] && (!$wakkaConfig["wikini_version"])) {
		$wakkaConfig["wikini_version"] = $wakkaConfig["wakka_version"];
	}
}
// Si la configuration a dj t charge
else $wakkaConfig = $_SESSION['wikiconfig'];

// Start installer if necessary
if (($wakkaConfig["wakka_version"] != WAKKA_VERSION) || ($wakkaConfig["wikini_version"] != WIKINI_VERSION)) {

	// Premire page de l'installateur
	if (!isset($_REQUEST["installAction"]) OR !$installAction = trim($_REQUEST["installAction"]))
		$installAction = "default";

	include(WIKINI_SETUP_PATH . WIKINI_HEADER . PHP_EX);

	if (file_exists(WIKINI_SETUP_PATH.$installAction . PHP_EX)) include(WIKINI_SETUP_PATH.$installAction . PHP_EX);
	else echo "<i>Invalid action</i>" ;

	include(WIKINI_SETUP_PATH . WIKINI_FOOTER . PHP_EX);
	exit;
}

// check for locking
if (file_exists("locked")) {
	// read password from lockfile
	$lines = file("locked");
	$lockpw = trim($lines[0]);
	
	// is authentification given?
	if (isset($_SERVER["PHP_AUTH_USER"])) {
		if (!(($_SERVER["PHP_AUTH_USER"] == "admin") && ($_SERVER["PHP_AUTH_PW"] == $lockpw))) $ask = 1;
	}
	else $ask = 1;
	
	if ($ask) {
		header("WWW-Authenticate: Basic realm=\"".$wakkaConfig["wakka_name"]." Install/Upgrade Interface\"");
		header("HTTP/1.0 401 Unauthorized");
		echo "Ce site est en cours de mise &agrave; jour. Veuillez essayer plus tard." ;
		exit;
	}
}

// Check if the server is configured to automatically compress the output
if (!ini_get('zlib.output_compression') && !ini_get('zlib.output_handler')) { 
    // Check if we can use ob_gzhandler (requires the zlib extension)
    if (function_exists('ob_gzhandler')) {
        // let ob_gzhandler do the dirty job
        // NB.: this must be done BEFORE session_start() when session.use_trans_sid is on
        ob_start('ob_gzhandler');
    }
    // else lets do the dirty job by ourselves...
    elseif (!empty($_SERVER['HTTP_ACCEPT_ENCODING']) && strstr($_SERVER['HTTP_ACCEPT_ENCODING'], 'gzip') && function_exists('gzencode')) {
        ob_start ('gzencode');
        // Tell the browser the content is compressed with gzip 
        header ("Content-Encoding: gzip"); 
    }
}

// configuration du cookie de session
// determine le chemin pour les cookies
$a = parse_url($wakkaConfig['base_url']);
$CookiePath = dirname($a['path']);
// ajoute un '/' terminal sauf si on est  la racine web
if ($CookiePath != '/') $CookiePath .= '/';

$a = session_get_cookie_params();
session_set_cookie_params($a['lifetime'], $CookiePath);

// Extraction de la page et de la mthode  appliquer depuis l'URL

// fetch wakka location
if (empty($_REQUEST['wiki'])) {
    // redirect to the root page
    header('Location: '.$wakkaConfig['base_url'].$wakkaConfig['root_page']);
    exit;
}

$wiki_param = $_REQUEST['wiki'];

// remove leading slash
$wiki_param = preg_replace("/^\//", "", $wiki_param);

// split into page/method, checking wiki name & method name (XSS proof)
if (preg_match('`^'.WN_TAG_HANDLER_CAPTURE.'$`', $wiki_param, $matches)) {
	list(, $page, $method) = $matches;
}
elseif (preg_match('`^'.WN_PAGE_TAG.'$`', $wiki_param)) {
	$page = $wiki_param;
}
else {
	echo "<p>Le nom de la page est incorrect.</p>";
	exit;
}


if (!isset($_SESSION['Cache'])) {
	$_SESSION['Cache'] = new CacheManager(); // create cache object
	$wiki = new Wiki($wakkaConfig, $_SESSION['Cache']); // create wiki object

	$_SESSION['Cache']->CacheIndexAllPage(
		$wiki->LoadAll("SELECT DISTINCT tag "
				."FROM ".$wiki->GetConfigValue("table_prefix")."pages")
	);
}
else {
	$wiki = new Wiki($wakkaConfig, $_SESSION['Cache']); // create wiki object
}

$wiki->SetCache($_SESSION['Cache']);

// Security (quick hack) : Check method syntax
if (!isset($method) or !(preg_match('#^[A-Za-z0-9_]*$#',$method))) $method = '';

$wiki->Run($page, $method);

?>
